import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, Injector, OnDestroy, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { Subscription } from 'rxjs';
import { MenuGroup, MenuGroupRoute } from '../../../interfaces/app-menu.interface';
import { AppMenuService } from '../../../services/app-menu.service';
import { PermissionsService } from '../../../services/permissions/permissions.service';
import { OTranslateService } from '../../../services/translate/o-translate.service';
import { OPermissions } from '../../../types/o-permissions.type';
import { OAppSidenavComponent } from '../o-app-sidenav.component';
export declare const DEFAULT_INPUTS_O_APP_SIDENAV_MENU_GROUP: string[];
export declare const DEFAULT_OUTPUTS_O_APP_SIDENAV_MENU_GROUP: string[];
export declare class OAppSidenavMenuGroupComponent implements OnInit, AfterViewInit, OnDestroy {
    protected injector: Injector;
    protected elRef: ElementRef;
    protected cd: ChangeDetectorRef;
    onItemClick: EventEmitter<any>;
    onClickEvent: EventEmitter<any>;
    protected translateService: OTranslateService;
    protected permissionsService: PermissionsService;
    appMenuService: AppMenuService;
    sidenav: OAppSidenavComponent;
    protected sidenavSubscription: Subscription;
    protected permissions: OPermissions;
    protected mutationObserver: MutationObserver;
    menuGroup: (MenuGroup | MenuGroupRoute);
    sidenavOpened: boolean;
    level: number;
    hidden: boolean;
    disabled: boolean;
    protected _contentExpansion: any;
    protected router: Router;
    routerSubscription: Subscription;
    active: boolean;
    constructor(injector: Injector, elRef: ElementRef, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    protected parsePermissions(): void;
    onClick(): void;
    toggle(event?: Event): void;
    navigate(): void;
    updateContentExpansion(): void;
    contentExpansion: string;
    readonly tooltip: string;
    onMenuItemClick(e: Event): void;
    getClass(): string;
}
