import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, Injector, OnDestroy, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { Subscription } from 'rxjs';
import { OAppLayoutComponent } from '../../../layouts/app-layout/o-app-layout.component';
import { AppMenuService } from '../../../services/app-menu.service';
import { AuthService } from '../../../services/auth.service';
import { DialogService } from '../../../services/dialog.service';
import { OUserInfoService } from '../../../services/o-user-info.service';
import { PermissionsService } from '../../../services/permissions/permissions.service';
import { OTranslateService } from '../../../services/translate/o-translate.service';
import { OPermissions } from '../../../types/o-permissions.type';
import { OAppSidenavComponent } from '../o-app-sidenav.component';
export declare const DEFAULT_INPUTS_O_APP_SIDENAV_MENU_ITEM: string[];
export declare const DEFAULT_OUTPUTS_O_APP_SIDENAV_MENU_ITEM: string[];
export declare class OAppSidenavMenuItemComponent implements OnInit, AfterViewInit, OnDestroy {
    protected injector: Injector;
    protected elRef: ElementRef;
    protected cd: ChangeDetectorRef;
    onClick: EventEmitter<any>;
    protected translateService: OTranslateService;
    protected authService: AuthService;
    protected dialogService: DialogService;
    protected permissionsService: PermissionsService;
    protected oUserInfoService: OUserInfoService;
    protected appMenuService: AppMenuService;
    protected userInfoSubscription: Subscription;
    protected sidenav: OAppSidenavComponent;
    protected router: Router;
    menuItem: any;
    menuItemType: string;
    sidenavOpened: boolean;
    disabled: boolean;
    protected appSidenavToggleSubscription: Subscription;
    protected routerSubscription: Subscription;
    protected oAppLayoutComponent: OAppLayoutComponent;
    protected permissions: OPermissions;
    protected mutationObserver: MutationObserver;
    hidden: boolean;
    active: boolean;
    constructor(injector: Injector, elRef: ElementRef, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    protected parsePermissions(): void;
    setUserInfoImage(): void;
    executeItemAction(): void;
    configureI18n(): void;
    isConfiguredLang(): boolean;
    logout(): void;
    navigate(): void;
    triggerClick(e: Event): void;
    isActionItem(): boolean;
    isLocaleItem(): boolean;
    isLogoutItem(): boolean;
    isUserInfoItem(): boolean;
    isDefaultItem(): boolean;
    readonly useFlagIcons: boolean;
    readonly tooltip: string;
    getClass(): string;
}
