import { ElementRef, Injector, OnDestroy, OnInit } from '@angular/core';
import { MediaObserver } from '@angular/flex-layout';
import { DateAdapter, MatDatepicker, MatDatepickerInput, MatDatepickerInputEvent } from '@angular/material';
import { Subscription } from 'rxjs';
import { OntimizeMomentDateAdapter } from '../../../shared/material/date/ontimize-moment-date-adapter';
import { DateCustomClassFunction } from '../../../types/date-custom-class.type';
import { DateFilterFunction } from '../../../types/date-filter-function.type';
import { FormValueOptions } from '../../../types/form-value-options.type';
import { ODateValueType } from '../../../types/o-date-value.type';
import { OFormComponent } from '../../form/o-form.component';
import { OFormDataComponent } from '../../o-form-data-component.class';
import { OFormControl } from '../o-form-control.class';
export declare const DEFAULT_OUTPUTS_O_DATE_INPUT: string[];
export declare const DEFAULT_INPUTS_O_DATE_INPUT: string[];
export declare class ODateInputComponent extends OFormDataComponent implements OnDestroy, OnInit {
    textInputEnabled: boolean;
    protected _oformat: string;
    protected olocale: string;
    protected updateLocaleOnChange: boolean;
    protected oStartView: 'month' | 'year';
    oMinDate: string;
    oMaxDate: string;
    protected oTouchUi: boolean;
    protected oStartAt: string;
    protected _filterDate: DateFilterFunction;
    protected _dateClass: DateCustomClassFunction;
    protected _valueType: ODateValueType;
    protected _minDateString: string;
    protected _maxDateString: string;
    protected media: MediaObserver;
    protected mediaSubscription: Subscription;
    protected onLanguageChangeSubscription: Subscription;
    protected dateValue: Date;
    datepicker: MatDatepicker<Date>;
    datepickerInput: MatDatepickerInput<Date>;
    private matInputRef;
    private momentSrv;
    private momentDateAdapter;
    constructor(form: OFormComponent, dateAdapter: DateAdapter<OntimizeMomentDateAdapter>, elRef: ElementRef, injector: Injector);
    ngOnInit(): void;
    subscribeToMediaChanges(): void;
    ngOnDestroy(): void;
    getValueAsDate(): any;
    getValue(): any;
    readonly showClearButton: boolean;
    open(): void;
    onChangeEvent(event: MatDatepickerInputEvent<any>): void;
    onClickInput(e: Event): void;
    filterDate: DateFilterFunction;
    dateClass: DateCustomClassFunction;
    oformat: string;
    minDateString: string;
    maxDateString: string;
    touchUi: boolean;
    protected ensureODateValueType(val: any): void;
    protected setFormValue(val: any, options?: FormValueOptions, setDirty?: boolean): void;
    valueType: any;
    createFormControl(cfg: any, validators: any): OFormControl;
    protected getValueAsMoment(val: any): any;
}
