import { AfterViewInit, ElementRef, EventEmitter, Injector, OnInit } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { FloatLabelType, MatCheckboxChange, MatFormFieldAppearance } from '@angular/material';
import { SnackBarService } from '../../../services/snackbar.service';
import { OTranslateService } from '../../../services/translate/o-translate.service';
import { Expression } from '../../../types/expression.type';
import { FormValueOptions } from '../../../types/form-value-options.type';
import { OInputsOptions } from '../../../types/o-inputs-options.type';
export declare const DEFAULT_INPUTS_O_SEARCH_INPUT: string[];
export declare const DEFAULT_OUTPUTS_O_SEARCH_INPUT: string[];
declare type ColumnObject = {
    column: string;
    checked: boolean;
};
export declare class OSearchInputComponent implements OnInit, AfterViewInit {
    protected injector: Injector;
    protected elRef: ElementRef;
    onSearch: EventEmitter<any>;
    colArray: ColumnObject[];
    _placeholder: string;
    placeholder: string;
    width: string;
    columns: string;
    showCaseSensitiveCheckbox: boolean;
    showMenu: boolean;
    protected _filterCaseSensitive: boolean;
    protected _floatLabel: FloatLabelType;
    protected _appearance: MatFormFieldAppearance;
    protected formGroup: FormGroup;
    protected term: FormControl;
    protected translateService: OTranslateService;
    protected oInputsOptions: OInputsOptions;
    protected snackBarService: SnackBarService;
    constructor(injector: Injector, elRef: ElementRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    floatLabel: FloatLabelType;
    appearance: MatFormFieldAppearance;
    filterCaseSensitive: boolean;
    getFormGroup(): FormGroup;
    getValue(): string;
    setValue(val: string, options?: FormValueOptions): void;
    getFormControl(): FormControl;
    readonly hasCustomWidth: boolean;
    readonly showFilterMenu: boolean;
    isChecked(column: ColumnObject): boolean;
    onCheckboxChange(column: ColumnObject, event: MatCheckboxChange): void;
    onSelectAllChange(event: MatCheckboxChange): void;
    areAllColumnsChecked(): boolean;
    getCountColumnsChecked(): number;
    onFilterCaseSensitiveChange(event: MatCheckboxChange): void;
    getActiveColumns(): string[];
    setActiveColumns(arg: string[]): void;
    protected checkActiveColumns(): boolean;
    protected triggerOnSearch(): void;
    onMenuClosed(): void;
    readonly filterExpression: Expression;
}
export {};
