import { AfterViewInit, ChangeDetectorRef, ElementRef, Injector, OnDestroy, OnInit } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { Subscription } from 'rxjs';
import { DateFilterFunction } from '../../../types/date-filter-function.type';
import { FormValueOptions } from '../../../types/form-value-options.type';
import { ODateValueType } from '../../../types/o-date-value.type';
import { OFormComponent } from '../../form/o-form.component';
import { OFormDataComponent } from '../../o-form-data-component.class';
import { ODateInputComponent } from '../date-input/o-date-input.component';
import { OHourInputComponent } from '../hour-input/o-hour-input.component';
import { OFormControl } from '../o-form-control.class';
export declare const DEFAULT_INPUTS_O_TIME_INPUT: string[];
export declare const DEFAULT_OUTPUTS_O_TIME_INPUT: string[];
export declare class OTimeInputComponent extends OFormDataComponent implements OnInit, AfterViewInit, OnDestroy {
    protected cd: ChangeDetectorRef;
    oDateFormat: string;
    oDateLocale: any;
    oDateStartView: 'month' | 'year';
    oDateMinDate: any;
    oDateMaxDate: any;
    oDateTouchUi: boolean;
    oDateStartAt: any;
    oDateFilterDate: DateFilterFunction;
    oDateTextInputEnabled: boolean;
    oHourFormat: number;
    oHourMin: string;
    oHourMax: string;
    oHourTextInputEnabled: boolean;
    oHourPlaceholder: string;
    oDatePlaceholder: string;
    protected oformat: string;
    protected _valueType: ODateValueType;
    protected blockGroupValueChanges: boolean;
    protected formGroup: FormGroup;
    protected dateInput: ODateInputComponent;
    protected hourInput: OHourInputComponent;
    protected subscription: Subscription;
    dateAttr: string;
    hourAttr: string;
    constructor(form: OFormComponent, elRef: ElementRef, injector: Injector, cd: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    createFormControl(cfg: any, validators: any): OFormControl;
    onFormControlChange(value: any): void;
    setValue(newValue: any, options?: FormValueOptions): void;
    onClickClearValue(event: Event): void;
    protected setInnerComponentsData(): void;
    protected updateComponentValue(): void;
    protected modifyFormControls(): void;
    protected registerFormControls(): void;
    valueType: any;
    ensureOFormValue(arg: any): void;
}
