import { SelectionModel } from '@angular/cdk/collections';
import { ElementRef, EventEmitter, Injector } from '@angular/core';
import { MatFormFieldAppearance, MatPaginator, PageEvent } from '@angular/material';
import { ActivatedRoute } from '@angular/router';
import { BehaviorSubject, Observable, Subscription } from 'rxjs';
import { OFilterBuilderComponent } from '../components/filter-builder/o-filter-builder.component';
import { OSearchInputComponent } from '../components/input/search-input/o-search-input.component';
import { IServiceDataComponent } from '../interfaces/service-data-component.interface';
import { OFormLayoutDialogComponent } from '../layouts/form-layout/dialog/o-form-layout-dialog.component';
import { OFormLayoutManagerComponent } from '../layouts/form-layout/o-form-layout-manager.component';
import { NavigationService } from '../services/navigation.service';
import { PermissionsService } from '../services/permissions/permissions.service';
import { AbstractServiceComponentStateClass } from '../services/state/o-component-state.class';
import { AbstractComponentStateService, DefaultServiceComponentStateService } from '../services/state/o-component-state.service';
import { OTranslateService } from '../services/translate/o-translate.service';
import { Expression } from '../types/expression.type';
import { OListInitializationOptions } from '../types/o-list-initialization-options.type';
import { OTableInitializationOptions } from '../types/table/o-table-initialization-options.type';
import { OFormComponent } from './form/o-form.component';
import { AbstractOServiceBaseComponent } from './o-service-base-component.class';
interface ItemClick {
    getItemData(): any;
}
export declare const DEFAULT_INPUTS_O_SERVICE_COMPONENT: string[];
export declare const DEFAULT_OUTPUTS_O_SERVICE_COMPONENT: string[];
export declare abstract class AbstractOServiceComponent<T extends AbstractComponentStateService<AbstractServiceComponentStateClass>> extends AbstractOServiceBaseComponent<T> implements IServiceDataComponent {
    protected elRef: ElementRef;
    protected form: OFormComponent;
    matpaginator: MatPaginator;
    protected permissionsService: PermissionsService;
    protected translateService: OTranslateService;
    protected navigationService: NavigationService;
    title: string;
    protected _title: string;
    protected ovisible: boolean;
    protected oenabled: boolean;
    protected controls: boolean;
    detailMode: string;
    protected detailFormRoute: string;
    protected recursiveDetail: boolean;
    detailButtonInRow: boolean;
    detailButtonInRowIcon: string;
    protected editFormRoute: string;
    protected recursiveEdit: boolean;
    editButtonInRow: boolean;
    editButtonInRowIcon: string;
    insertButton: boolean;
    paginationControls: boolean;
    disablePageSizeCalculation: boolean;
    pageSizeOptions: number[];
    protected _rowHeight: string;
    protected rowHeightSubject: BehaviorSubject<string>;
    rowHeightObservable: Observable<string>;
    protected checkViewPortSubject: BehaviorSubject<boolean>;
    checkViewPortObservable: Observable<boolean>;
    rowHeight: string;
    protected insertFormRoute: string;
    protected recursiveInsert: boolean;
    protected _filterCaseSensitive: boolean;
    filterCaseSensitive: boolean;
    protected _quickFilter: boolean;
    quickFilter: boolean;
    quickFilterPlaceholder: string;
    onClick: EventEmitter<any>;
    onDoubleClick: EventEmitter<any>;
    onDataLoaded: EventEmitter<any>;
    onPaginatedDataLoaded: EventEmitter<any>;
    onSearch: EventEmitter<any>;
    filterBuilder: OFilterBuilderComponent;
    selection: SelectionModel<Element>;
    protected onTriggerUpdateSubscription: any;
    protected formLayoutManager: OFormLayoutManagerComponent;
    protected formLayoutManagerTabIndex: number;
    oFormLayoutDialog: OFormLayoutDialogComponent;
    protected tabsSubscriptions: any;
    quickFilterComponent: OSearchInputComponent;
    searchInputComponent: OSearchInputComponent;
    protected quickFilterColArray: string[];
    protected dataResponseArray: any[];
    protected quickFilterSubscription: Subscription;
    _pageSizeOptions: number[];
    protected clickTimer: any;
    protected clickDelay: number;
    protected clickPrevent: boolean;
    protected _quickFilterAppearance: MatFormFieldAppearance;
    constructor(injector: Injector, elRef: ElementRef, form: OFormComponent);
    initialize(): void;
    afterViewInit(): void;
    destroy(): void;
    isVisible(): boolean;
    hasControls(): boolean;
    hasTitle(): boolean;
    getSelectedItems(): any[];
    clearSelection(): void;
    setSelected(item: any): void;
    protected navigateToDetail(route: any[], qParams: any, relativeTo: ActivatedRoute): void;
    insertDetail(): void;
    viewDetail(item: any): void;
    editDetail(item: any): void;
    protected addFormLayoutManagerRoute(routeArr: any[]): void;
    protected getEncodedParentKeys(): string;
    getInsertRoute(): any[];
    getItemModeRoute(item: any, modeRoute: string): any[];
    protected getQueryConfiguration(): any;
    getRouteOfSelectedRow(item: any): any[];
    protected deleteLocalItems(): void;
    reinitialize(options: OListInitializationOptions | OTableInitializationOptions): void;
    setFilterBuilder(filterBuilder: OFilterBuilderComponent): void;
    getComponentFilter(existingFilter?: any): any;
    protected getQuickFilterExpression(): Expression;
    protected getFilterBuilderExpression(): Expression;
    protected storeNavigationFormRoutes(activeMode: string, queryConf?: any): void;
    protected saveDataNavigationInLocalStorage(): void;
    protected getKeysValues(): any[];
    getRouteKey(): string;
    readonly elementRef: ElementRef;
    showCaseSensitiveCheckbox(): boolean;
    registerQuickFilter(arg: any): void;
    isFilterCaseSensitive(): boolean;
    configureFilterValue(value: string): string;
    getQuickFilterValue(): string;
    getQuickFilterColumns(): string[];
    filterData(value?: string, loadMore?: boolean): void;
    protected getQuickFilterDataFromArray(quickfilter: string, dataArray: any[]): any[];
    protected getSortedDataFromArray(dataArray: any[]): any[];
    protected setData(data: any, sqlTypes?: any, replace?: boolean): void;
    protected parseResponseArray(data: any[], replace?: boolean): any[];
    protected registerFormLayoutManagerState(): void;
    applyDefaultConfiguration(): void;
    onChangePage(e: PageEvent): void;
    currentPage: number;
    protected _currentPage: number;
    readonly totalRecords: number;
    protected getPaginationDataFromArray(dataArray: any[]): any[];
    handleItemClick(item: ItemClick): void;
    protected itemClickDone(item: ItemClick): void;
    handleItemDblClick(item: ItemClick): void;
    protected itemDblClickDone(item: ItemClick): void;
    quickFilterAppearance: MatFormFieldAppearance;
    protected getSqlTypesOfKeys(): {};
}
export declare class OServiceComponent extends AbstractOServiceComponent<DefaultServiceComponentStateService> {
}
export {};
