import { EventEmitter, Injector, OnInit, QueryList, Renderer2 } from '@angular/core';
import { AsyncValidatorFn, FormControl, FormGroup, ValidatorFn } from '@angular/forms';
import { Subscription } from 'rxjs';
import { OMatErrorDirective } from '../../../../directives/o-mat-error.directive';
import { OTableColumn } from '../../../../interfaces/o-table-column.interface';
import { SnackBarService } from '../../../../services/snackbar.service';
import { OTranslateService } from '../../../../services/translate/o-translate.service';
import { OValidatorComponent } from '../../../../shared/components/validation/o-validator.component';
import { ErrorData } from '../../../../types/error-data.type';
import { OMatErrorOptions } from '../../../../types/o-mat-error.type';
import { ComponentWithValidatorsAndErrorsData } from '../../../../util/errors';
import { OTableComponent } from '../../o-table.component';
export declare const DEFAULT_INPUTS_O_TABLE_CELL_EDITOR: string[];
export declare const DEFAULT_OUTPUTS_O_TABLE_CELL_EDITOR: string[];
export declare class OBaseTableCellEditor implements OnInit, ComponentWithValidatorsAndErrorsData {
    protected injector: Injector;
    protected translateService: OTranslateService;
    orequired: boolean;
    showPlaceHolder: boolean;
    olabel: string;
    updateRecordOnEdit: boolean;
    showNotificationOnEdit: boolean;
    protected _enabled: boolean;
    protected _tableColumn: OTableColumn;
    protected _table: OTableComponent;
    protected _rowData: any;
    formControl: FormControl;
    controlArgs: any;
    formGroup: FormGroup;
    editionStarted: EventEmitter<object>;
    editionCancelled: EventEmitter<object>;
    editionCommitted: EventEmitter<object>;
    onPostUpdateRecord: EventEmitter<object>;
    editorCreated: EventEmitter<object>;
    protected inputRef: any;
    protected type: string;
    registerInColumn: boolean;
    protected snackBarService: SnackBarService;
    protected oldValue: any;
    cellEditorId: string;
    errorsData: ErrorData[];
    protected validatorsSubscription: Subscription;
    validatorChildren: QueryList<OValidatorComponent>;
    protected renderer: Renderer2;
    onDocumentKeyup(event: KeyboardEvent): void;
    tooltipPosition: string;
    tooltipShowDelay: number;
    tooltipHideDelay: number;
    errorOptions: OMatErrorOptions;
    oMatErrorChildren: QueryList<OMatErrorDirective>;
    constructor(injector: Injector);
    ngOnInit(): void;
    ngOnChanges(): void;
    ngAfterViewInit(): void;
    initialize(): void;
    protected handleKeyup(event: KeyboardEvent): void;
    protected checkKey(event: KeyboardEvent, key: string, keyCode: number): boolean;
    createFormControl(): void;
    registerEditor(): void;
    getCellData(): any;
    startEdition(data: any): void;
    endEdition(saveChanges: boolean): void;
    commitEdition(): void;
    tableColumn: OTableColumn;
    readonly tableColumnAttr: string;
    table: OTableComponent;
    rowData: any;
    resolveValidators(): ValidatorFn[];
    resolveAsyncValidators(): AsyncValidatorFn[];
    getActiveOErrors(): ErrorData[];
    getErrorText(oError: any): any;
    protected updateValidators(): void;
    hasError(error: string): boolean;
    hasSomeError(): boolean;
    hasErrorExclusive(error: string): boolean;
    getErrorValue(error: string, prop: string): string;
    onEscClicked(): void;
    protected isSilentControl(): boolean;
    getPlaceholder(): string;
    protected onUpdateSuccess(res: any): void;
    enabled: boolean;
    getFormControl(): FormControl;
    setEditingRowClass(addClass: boolean): void;
    readonly tooltip: string;
    readonly tooltipClass: string;
}
