import { AfterViewChecked, ElementRef, Injector, OnInit, TemplateRef } from '@angular/core';
import { FormControl } from '@angular/forms';
import { DateAdapter, MatDatepicker, MatDatepickerInput, MatDatepickerInputEvent } from '@angular/material';
import { NgxMaterialTimepickerComponent } from 'ngx-material-timepicker';
import { FormValueOptions } from '../../../../../types/form-value-options.type';
import { OBaseTableCellEditor } from '../o-base-table-cell-editor.class';
export declare const DEFAULT_INPUTS_O_TABLE_CELL_EDITOR_TIME: string[];
export declare const DEFAULT_OUTPUTS_O_TABLE_CELL_EDITOR_TIME: string[];
export declare class OTableCellEditorTimeComponent extends OBaseTableCellEditor implements OnInit, AfterViewChecked {
    protected injector: Injector;
    private adapter;
    templateref: TemplateRef<any>;
    protected dateInput: ElementRef;
    protected hourInput: ElementRef;
    picker: NgxMaterialTimepickerComponent;
    oStartView: 'month' | 'year';
    datepickerInput: MatDatepickerInput<Date>;
    formControlHour: FormControl;
    formControlDate: FormControl;
    oDateFormat: string;
    oHourMax: string;
    oHourMin: string;
    oDateTouchUi: boolean;
    oDateStartAt: string;
    private _oDateLocale;
    protected oHourPlaceholder: string;
    protected oDatePlaceholder: string;
    oHourFormat: number;
    protected onKeyboardInputDone: boolean;
    protected oMinDate: string;
    protected oMaxDate: string;
    protected _minDateString: string;
    protected _maxDateString: string;
    protected datepicker: MatDatepicker<Date>;
    private momentSrv;
    enabledCommitOnTabPress: boolean;
    protected activeKeys: object;
    onDocumentKeydown(event: KeyboardEvent): void;
    constructor(injector: Injector, adapter: DateAdapter<any>);
    initialize(): void;
    createInternalFormControl(): void;
    ngAfterViewChecked(): void;
    setTime(event: string): void;
    onDateChange(event: MatDatepickerInputEvent<any>): void;
    protected updateValeOnInputChange(blurEvent: any): void;
    protected parseHour(value: string): string;
    onHourChange(event: any): void;
    setTimestampValue(value: any, options?: FormValueOptions): void;
    protected convertToFormatString(value: any): string;
    openDatepicker(d: MatDatepicker<Date>): void;
    getPlaceholderHour(): string;
    getPlaceholderDate(): string;
    open(e?: Event): void;
    protected handleKeydown(e: KeyboardEvent): void;
    protected handleKeyup(e: KeyboardEvent): void;
    protected updateComponentValue(): void;
    protected modifyPickerMethods(): void;
    hasErrorDate(error: string): boolean;
    hasErrorExclusive(error: string): boolean;
    hasErrorHour(error: string): boolean;
    getCellDataDate(): any;
    getCellDataHour(): any;
    startEdition(data: any): void;
    readonly formatString: string;
    minDateString: string;
    maxDateString: string;
    oDateLocale: string;
    readonly minDate: Date;
    readonly maxDate: Date;
    onDatepickerClosed(): void;
    onTimepickerClosed(): void;
    commitEdition(): void;
    onKeyDown(e: KeyboardEvent): void;
}
