import { AfterViewInit, ComponentFactoryResolver, EventEmitter, Injector, OnDestroy, OnInit, ViewContainerRef } from '@angular/core';
import { AsyncValidatorFn, ValidatorFn } from '@angular/forms';
import { OTableColumn } from '../../../interfaces/o-table-column.interface';
import { OPercentageValueBaseType } from '../../../pipes/o-percentage.pipe';
import { DateFilterFunction } from '../../../types/date-filter-function.type';
import { ErrorData } from '../../../types/error-data.type';
import { Expression } from '../../../types/expression.type';
import { ODateValueType } from '../../../types/o-date-value.type';
import { OTableComponent } from '../o-table.component';
export declare const DEFAULT_INPUTS_O_TABLE_COLUMN: string[];
export declare const DEFAULT_OUTPUTS_O_TABLE_COLUMN: string[];
export declare class OTableColumnComponent implements OTableColumn, OnDestroy, OnInit, AfterViewInit {
    table: OTableComponent;
    protected resolver: ComponentFactoryResolver;
    protected injector: Injector;
    renderer: any;
    editor: any;
    type: string;
    attr: string;
    title: string;
    titleAlign: string;
    contentAlign: 'start' | 'center' | 'end';
    sqlType: string;
    protected _SQLType: number;
    protected _defaultSQLTypeKey: string;
    protected _orderable: boolean;
    protected _resizable: boolean;
    protected _searchable: boolean;
    protected _groupable: boolean;
    editable: boolean;
    width: string;
    minWidth: string;
    maxWidth: string;
    tooltip: boolean;
    tooltipValue: string;
    tooltipFunction: (rowData: any) => any;
    class: string;
    multiline: boolean;
    protected _multiline: boolean;
    angularValidatorsFn: ValidatorFn[];
    angularValidatorsFnErrors: ErrorData[];
    angularAsyncValidatorsFn: AsyncValidatorFn[];
    filterExpressionFunction: (columnAttr: string, quickFilter?: string) => Expression;
    _filterSource: 'render' | 'data' | 'both';
    filterFunction: (cellValue: any, rowValue: any, quickFilter?: string) => boolean;
    protected format: string;
    protected grouping: any;
    protected thousandSeparator: string;
    protected decimalSeparator: string;
    protected currencySymbol: string;
    protected currencySymbolPosition: string;
    protected trueValue: any;
    protected falseValue: any;
    protected renderTrueValue: any;
    protected renderFalseValue: any;
    protected renderType: string;
    protected booleanType: string;
    protected imageType: string;
    protected avatar: string;
    protected emptyImage: string;
    protected icon: string;
    protected action: string;
    protected text: string;
    protected iconPosition: string;
    protected entity: string;
    protected service: string;
    protected columns: string;
    protected valueColumn: string;
    protected parentKeys: string;
    protected queryMethod: string;
    protected serviceType: string;
    protected translate: boolean;
    protected translateArgsFn: (rowData: any) => any[];
    oDateFormat: string;
    oHourFormat: number;
    valueBase: OPercentageValueBaseType;
    protected orequired: boolean;
    showPlaceHolder: boolean;
    olabel: string;
    updateRecordOnEdit: boolean;
    showNotificationOnEdit: boolean;
    protected locale: string;
    protected oStartView: 'month' | 'year';
    protected oMinDate: string;
    protected oMaxDate: string;
    protected oTouchUi: boolean;
    protected oStartAt: string;
    protected filterDate: DateFilterFunction;
    protected dateValueType: ODateValueType;
    min: number;
    max: number;
    step: number;
    minDecimalDigits: number;
    maxDecimalDigits: number;
    indeterminateOnNull: boolean;
    autoCommit: boolean;
    onClick: EventEmitter<object>;
    editionStarted: EventEmitter<object>;
    editionCancelled: EventEmitter<object>;
    editionCommitted: EventEmitter<object>;
    onPostUpdateRecord: EventEmitter<object>;
    asyncLoad: boolean;
    container: ViewContainerRef;
    private subscriptions;
    constructor(table: OTableComponent, resolver: ComponentFactoryResolver, injector: Injector);
    static addEditor(type: string, editorClassReference: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    parseTitleAlign(): string;
    readonly originalWidth: string;
    protected createRenderer(): void;
    buildCellEditor(type: string, resolver: ComponentFactoryResolver, container: ViewContainerRef, propsOrigin: any, registerInColumn?: boolean): any;
    protected createEditor(): void;
    registerRenderer(renderer: any): void;
    registerEditor(editor: any): void;
    orderable: any;
    resizable: any;
    searchable: any;
    groupable: any;
    getSQLType(): number;
    filterSource: string;
}
