import { AfterViewInit, ElementRef, EventEmitter } from '@angular/core';
import { FormControl } from '@angular/forms';
import { MatCheckboxChange, MatDialogRef, MatSelectionList, MatSelectionListChange, MatSlideToggleChange } from '@angular/material';
import { Observable } from 'rxjs';
import { OColumnValueFilter } from '../../../../../types/table/o-column-value-filter.type';
import { TableFilterByColumnData, TableFilterByColumnDialogResult } from '../../../../../types/table/o-table-filter-by-column-data.type';
import { OColumn } from '../../../column/o-column.class';
import { OFilterColumn } from '../../header/table-columns-filter/columns/o-table-columns-filter-column.component';
export declare class OTableFilterByColumnDataDialogComponent implements AfterViewInit {
    dialogRef: MatDialogRef<OTableFilterByColumnDataDialogComponent>;
    acceptAction: TableFilterByColumnDialogResult;
    cancelAction: TableFilterByColumnDialogResult;
    clearAction: TableFilterByColumnDialogResult;
    column: OColumn;
    preloadValues: boolean;
    mode: string;
    startView: 'month' | 'year' | 'multi-year' | '';
    onSortFilterValuesChange: EventEmitter<OFilterColumn>;
    private isCustomFilterSubject;
    isCustomFilter: Observable<boolean>;
    private isDefaultFilterSubject;
    isDefaultFilter: Observable<boolean>;
    fcText: FormControl;
    fcFrom: FormControl;
    fcTo: FormControl;
    protected columnData: TableFilterByColumnData[];
    protected tableData: any[];
    private listDataSubject;
    protected _listData: Observable<TableFilterByColumnData[]>;
    filter: ElementRef;
    filterValueList: MatSelectionList;
    activeSortDirection: 'asc' | 'desc' | '';
    constructor(dialogRef: MatDialogRef<OTableFilterByColumnDataDialogComponent>, data: any);
    ngAfterViewInit(): void;
    listData: Observable<TableFilterByColumnData[]>;
    protected initializeDataList(filter?: OColumnValueFilter): void;
    protected initializeFilterEvent(): void;
    protected initializeCustomFilterValues(filter: OColumnValueFilter): void;
    readonly selectedValues: TableFilterByColumnData[];
    areAllSelected(): boolean;
    isIndeterminate(): boolean;
    onSelect(event: MatSelectionListChange): void;
    onSelectAllChange(event: MatCheckboxChange): void;
    protected getDistinctValues(filter: OColumnValueFilter): void;
    getColumnValuesFilter(): OColumnValueFilter;
    clearValues(): void;
    onClickSortValues(): void;
    protected sortData(): void;
    protected sortFunction(a: any, b: any): number;
    onSlideChange(e: MatSlideToggleChange): void;
    isTextType(): boolean;
    isNumericType(): boolean;
    isDateType(): boolean;
    getFixedDimensionClass(): boolean;
    getSortByAlphaIcon(): string;
    protected getFilterColumn(): OFilterColumn;
    getStartedViewDatepicker(): string;
    protected getTypedValue(control: FormControl): any;
    protected getColumnDataUsingRenderer(): any[];
}
