import { ElementRef, Injector, OnDestroy } from '@angular/core';
import { Router } from '@angular/router';
import { Subscription } from 'rxjs';
import { AuthService } from '../../services/auth.service';
import { DialogService } from '../../services/dialog.service';
import { OUserInfoService, UserInfo } from '../../services/o-user-info.service';
import { OUserInfoConfigurationDirective } from './user-info-configuration/o-user-info-configuration.directive';
export declare const DEFAULT_INPUTS_O_USER_INFO: string[];
export declare const DEFAULT_OUTPUTS_O_USER_INFO: any[];
export declare class OUserInfoComponent implements OnDestroy {
    protected elRef: ElementRef;
    protected injector: Injector;
    protected router: Router;
    protected dialogService: DialogService;
    protected authService: AuthService;
    protected oUserInfoService: OUserInfoService;
    userInfoSubscription: Subscription;
    protected userInfo: UserInfo;
    showLogout: boolean;
    showSettings: boolean;
    showProfile: boolean;
    userInfoConfiguration: OUserInfoConfigurationDirective;
    constructor(elRef: ElementRef, injector: Injector, router: Router);
    ngOnDestroy(): void;
    onLogoutClick(): void;
    onSettingsClick(): void;
    onProfileClick(): void;
    readonly existsUserInfo: boolean;
    readonly avatar: string;
    readonly username: string;
    registerUserInfoConfiguration(userInfoMenu: OUserInfoConfigurationDirective): void;
    private updateInputsByConfiguration;
}
