import { AfterViewInit, EventEmitter } from '@angular/core';
import { ThemePalette } from '@angular/material';
import { OAppHeaderComponent } from '../../components/app-header/o-app-header.component';
import { OAppSidenavComponent } from '../../components/app-sidenav/o-app-sidenav.component';
import { OUserInfoConfigurationDirective } from '../../components/user-info/user-info-configuration/o-user-info-configuration.directive';
import { OAppLayoutMode, OSidenavMode } from '../../util/codes';
export declare const DEFAULT_INPUTS_O_APP_LAYOUT: string[];
export declare const DEFAULT_OUTPUTS_O_APP_LAYOUT: any[];
export declare class OAppLayoutComponent implements AfterViewInit {
    sidenavOpened: boolean;
    showUserInfo: boolean;
    showLanguageSelector: boolean;
    useFlagIcons: boolean;
    protected _showHeader: boolean;
    showTitle: boolean;
    staticTitle: string;
    showStaticTitle: boolean;
    headerColor: ThemePalette;
    headerHeight: string;
    appSidenav: OAppSidenavComponent;
    appHeader: OAppHeaderComponent;
    userInfoConfiguration: OUserInfoConfigurationDirective;
    protected _mode: OAppLayoutMode;
    protected _sidenavMode: OSidenavMode;
    openedSidenavImg: string;
    closedSidenavImg: string;
    beforeOpenSidenav: EventEmitter<boolean>;
    afterOpenSidenav: EventEmitter<boolean>;
    beforeCloseSidenav: EventEmitter<boolean>;
    afterCloseSidenav: EventEmitter<boolean>;
    showHeader: boolean;
    mode: OAppLayoutMode;
    sidenavMode: OSidenavMode;
    sidenavToggle(opened: boolean): void;
    afterToggle(opened: boolean): void;
    ngAfterViewInit(): void;
}
