import { AfterViewInit, ComponentFactory, ComponentFactoryResolver, Injector } from '@angular/core';
import { MatDialogRef } from '@angular/material';
import { ILayoutManagerComponent } from '../../../interfaces/layout-manager-component.interface';
import { OFormLayoutManagerMode } from '../../../interfaces/o-form-layout-manager-mode.interface';
import { OFormLayoutManagerComponent } from '../../../layouts/form-layout/o-form-layout-manager.component';
import { DialogService } from '../../../services/dialog.service';
import { OFormLayoutManagerContentDirective } from '../directives/o-form-layout-manager-content.directive';
export declare class OFormLayoutDialogComponent implements OFormLayoutManagerMode, AfterViewInit {
    dialogRef: MatDialogRef<OFormLayoutDialogComponent>;
    protected injector: Injector;
    protected componentFactoryResolver: ComponentFactoryResolver;
    formLayoutManager: OFormLayoutManagerComponent;
    queryParams: any;
    params: object;
    urlSegments: any[];
    label: string;
    title: string;
    data: any;
    protected componentFactory: ComponentFactory<any>;
    protected dialogService: DialogService;
    contentDirective: OFormLayoutManagerContentDirective;
    constructor(dialogRef: MatDialogRef<OFormLayoutDialogComponent>, injector: Injector, componentFactoryResolver: ComponentFactoryResolver, data: any);
    ngAfterViewInit(): void;
    updateNavigation(data: any): void;
    updateActiveData(data: any): void;
    closeDialog(options?: any): void;
    getRouteOfActiveItem(): any[];
    getParams(): any;
    getFormCacheData(): any;
    isMainComponent(comp: ILayoutManagerComponent): boolean;
    closeDetail(options: any): void;
    getDataToStore(): any;
    setModifiedState(formAttr: string, modified: boolean, confirmExit: boolean): void;
    canAddDetailComponent(): boolean;
    getIdOfActiveItem(): string;
}
