import { AfterViewInit, ComponentFactoryResolver, ElementRef, Injector, Renderer2 } from '@angular/core';
import { Router } from '@angular/router';
import { ResizeEvent } from 'angular-resizable-element';
import { BehaviorSubject, Observable } from 'rxjs';
import { ILayoutManagerComponent } from '../../../interfaces/layout-manager-component.interface';
import { OFormLayoutManagerMode } from '../../../interfaces/o-form-layout-manager-mode.interface';
import { OFormLayoutManagerComponent } from '../../../layouts/form-layout/o-form-layout-manager.component';
import { DialogService } from '../../../services/dialog.service';
import { OFormLayoutManagerComponentStateClass } from '../../../services/state/o-form-layout-manager-component-state.class';
import { FormLayoutDetailComponentData } from '../../../types/form-layout-detail-component-data.type';
import { OFormLayoutManagerContentDirective } from '../directives/o-form-layout-manager-content.directive';
export declare const DEFAULT_INPUTS_O_FORM_LAYOUT_SPLIT_PANE: string[];
export declare const DEFAULT_OUTPUTS_O_FORM_LAYOUT_SPLIT_PANE: any[];
export declare class OFormLayoutSplitPaneComponent implements AfterViewInit, OFormLayoutManagerMode {
    protected injector: Injector;
    protected elementRef: ElementRef;
    protected componentFactoryResolver: ComponentFactoryResolver;
    renderer: Renderer2;
    formLayoutManager: OFormLayoutManagerComponent;
    data: FormLayoutDetailComponentData;
    showLoading: BehaviorSubject<boolean>;
    protected router: Router;
    contentDirective: OFormLayoutManagerContentDirective;
    protected mainWrapper: ElementRef;
    protected detailWrapper: ElementRef;
    protected _options: any;
    options: any;
    protected dialogService: DialogService;
    constructor(injector: Injector, elementRef: ElementRef, componentFactoryResolver: ComponentFactoryResolver, renderer: Renderer2, formLayoutManager: OFormLayoutManagerComponent);
    readonly state: OFormLayoutManagerComponentStateClass;
    ngAfterViewInit(): void;
    protected setOption(el: any, optionName: string, propertyName: string): void;
    getFormCacheData(): FormLayoutDetailComponentData;
    setModifiedState(formAttr: string, modified: boolean, confirmExit: boolean): void;
    setDetailComponent(compData: FormLayoutDetailComponentData): void;
    onResizeEnd(property: string, event: ResizeEvent, el: any): void;
    protected createComponent(): void;
    getDataToStore(): any;
    getParams(): any;
    initializeComponentState(): void;
    updateActiveData(data: any): void;
    getRouteOfActiveItem(): any[];
    isMainComponent(comp: ILayoutManagerComponent): boolean;
    openDetail(detail: FormLayoutDetailComponentData): void;
    closeDetail(): void;
    updateNavigation(data: any, keysValues: any, insertionMode?: boolean): void;
    canAddDetailComponent(): boolean | Observable<boolean>;
    getIdOfActiveItem(): string;
}
