import { AfterViewInit, ComponentFactoryResolver, ElementRef, EventEmitter, Injector, OnDestroy, QueryList, ViewContainerRef } from '@angular/core';
import { MatTabChangeEvent, MatTabGroup } from '@angular/material';
import { Router } from '@angular/router';
import { BehaviorSubject, Subject, Subscription } from 'rxjs';
import { ILayoutManagerComponent } from '../../../interfaces/layout-manager-component.interface';
import { OFormLayoutManagerMode } from '../../../interfaces/o-form-layout-manager-mode.interface';
import { DialogService } from '../../../services/dialog.service';
import { OFormLayoutManagerComponentStateClass } from '../../../services/state/o-form-layout-manager-component-state.class';
import { FormLayoutCloseDetailOptions, FormLayoutDetailComponentData } from '../../../types/form-layout-detail-component-data.type';
import { OFormLayoutManagerContentDirective } from '../directives/o-form-layout-manager-content.directive';
import { OFormLayoutManagerComponent } from '../o-form-layout-manager.component';
export declare const DEFAULT_INPUTS_O_FORM_LAYOUT_TABGROUP: string[];
export declare const DEFAULT_OUTPUTS_O_FORM_LAYOUT_TABGROUP: string[];
export declare class OFormLayoutTabGroupComponent implements OFormLayoutManagerMode, AfterViewInit, OnDestroy {
    protected injector: Injector;
    protected componentFactoryResolver: ComponentFactoryResolver;
    protected location: ViewContainerRef;
    protected elementRef: ElementRef;
    formLayoutManager: OFormLayoutManagerComponent;
    data: FormLayoutDetailComponentData[];
    title: string;
    options: any;
    showLoading: BehaviorSubject<boolean>;
    tabGroup: MatTabGroup;
    tabsDirectives: QueryList<OFormLayoutManagerContentDirective>;
    protected subscriptions: Subscription;
    protected router: Router;
    protected dialogService: DialogService;
    onMainTabSelected: EventEmitter<any>;
    onSelectedTabChange: EventEmitter<any>;
    onCloseTab: EventEmitter<any>;
    protected previousSelectedIndex: number;
    updateTabComponentsState: Subject<any>;
    tabsModificationsCache: any[];
    constructor(injector: Injector, componentFactoryResolver: ComponentFactoryResolver, location: ViewContainerRef, elementRef: ElementRef, formLayoutManager: OFormLayoutManagerComponent);
    readonly state: OFormLayoutManagerComponentStateClass;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    readonly mainTabTitle: string;
    readonly disableAnimation: any;
    readonly headerPosition: any;
    readonly color: any;
    readonly backgroundColor: any;
    readonly templateMatTabLabel: any;
    readonly icon: any;
    readonly isIconPositionLeft: boolean;
    readonly maxTabs: number;
    addTab(compData: FormLayoutDetailComponentData): void;
    reloadTab(compData: FormLayoutDetailComponentData): void;
    onTabSelectChange(arg: MatTabChangeEvent): void;
    closeTab(index: number, options?: FormLayoutCloseDetailOptions): void;
    createTabComponent(tabData: FormLayoutDetailComponentData, content: OFormLayoutManagerContentDirective): void;
    getFormCacheData(): FormLayoutDetailComponentData;
    getRouteOfActiveItem(): any[];
    setModifiedState(formAttr: string, modified: boolean, confirmExit: boolean): void;
    updateNavigation(data: any, keysValues: any, insertionMode?: boolean): void;
    updateActiveData(data: any): void;
    getDataToStore(): any;
    initializeComponentState(): void;
    protected createTabsFromState(): void;
    protected createDetailComponent(component: any, paramsObj: any): FormLayoutDetailComponentData;
    getParams(): any;
    isMainComponent(comp: ILayoutManagerComponent): boolean;
    openDetail(detail: FormLayoutDetailComponentData): void;
    closeDetail(options?: FormLayoutCloseDetailOptions): void;
    canAddDetailComponent(): boolean;
    isTabDataModified(tabData: FormLayoutDetailComponentData): boolean;
    closeDetails(detailsKeysData?: any[], options?: FormLayoutCloseDetailOptions): void;
    getIdOfActiveItem(): string;
}
