import { Injector } from '@angular/core';
import { Router } from '@angular/router';
import { Subject } from 'rxjs';
import { AppConfig } from '../config/app-config';
import { MenuGroup, MenuItem, MenuItemRoute } from '../interfaces/app-menu.interface';
import { MenuRootItem } from '../types/menu-root-item.type';
export declare class AppMenuService {
    protected injector: Injector;
    protected router: Router;
    protected _config: AppConfig;
    protected MENU_ROOTS: MenuRootItem[];
    protected ALL_MENU_ITEMS: MenuRootItem[];
    protected activeItem: MenuItemRoute;
    onClick: Subject<any>;
    constructor(injector: Injector);
    getMenuRoots(): MenuRootItem[];
    getMenuRootById(id: string): MenuRootItem;
    getAllMenuItems(): MenuRootItem[];
    getMenuItemById(id: string): MenuItem | MenuGroup;
    getMenuItemType(item: MenuRootItem): string;
    isMenuGroup(item: MenuRootItem): boolean;
    isMenuGroupRoute(item: MenuRootItem): boolean;
    isItemActive(item: MenuItemRoute): boolean;
    isRouteItem(item: MenuItemRoute): boolean;
    private getMenuItems;
    private setActiveItem;
}
