import { Injector } from '@angular/core';
import { Observable, Subject } from 'rxjs';
import { SessionInfo } from '../types';
import { DialogService } from './dialog.service';
export declare abstract class AuthService {
    protected injector: Injector;
    onLogin: Subject<any>;
    onLogout: Subject<any>;
    protected dialogService: DialogService;
    constructor(injector: Injector);
    abstract login(user: string, password: string): Observable<any>;
    abstract logout(): Observable<any>;
    abstract clearSessionData(): void;
    abstract isLoggedIn(): boolean;
    abstract getSessionInfo(): SessionInfo;
    logoutWithConfirmation(): void;
}
